(function (global, factory) {
  typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports) :
  typeof define === 'function' && define.amd ? define(['exports'], factory) :
  (global = global || self, factory(global['hofs/bypassCache'] = {}));
}(this, function (exports) { 'use strict';

  /**
   * Create a fetch which bypass cache
   */
  var bypassCache = function bypassCache(fetch) {
    return function (input, init) {
      var bypassCacheUrl;

      if (input.includes("?")) {
        bypassCacheUrl = input + "&_v=" + Math.random();
      } else {
        bypassCacheUrl = input + "?_v=" + Math.random();
      }

      return fetch(bypassCacheUrl, init);
    };
  };

  exports.bypassCache = bypassCache;

  Object.defineProperty(exports, '__esModule', { value: true });

}));
